package us.maccaleonardi.memory;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.WindowEvent;
import java.io.IOException;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class Main extends JFrame {

	private static final long serialVersionUID = 1L;
	private static JPanel contentPane;
	private static JFrame f;
	private Memory memory;

	/**
	 * Create the frame.
	 * @throws IOException 
	 */
	public Main() throws IOException {
		setResizable(false);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		addWindowListener(new java.awt.event.WindowAdapter() {
		    @Override
		    public void windowClosing(java.awt.event.WindowEvent windowEvent) {
		        Memory.inGame = false;
		    }
		});
		if(Helper.cards == 8)
			setBounds(100, 100, 1004, 476);
		else
			setBounds(100, 100, 1004, 455 * 2);
		//setBounds(100, 100, 1004, 476);
		contentPane = new JPanel();
		contentPane.setBorder(new LineBorder(new Color(0, 0, 0)));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		JPanel panel = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panel.getLayout();
		flowLayout.setAlignOnBaseline(true);
		panel.setBackground(Color.decode("#dcdde1"));
		if(Helper.cards == 8)
			panel.setBounds(5, 5, 700, 435);
		else
			panel.setBounds(5, 5, 700, 435 * 2);
		contentPane.add(panel);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBounds(717, 5, 275, 429);
		contentPane.add(panel_1);
		panel_1.setLayout(new GridLayout(3, 1, 0, 0));
		
		JLabel lblNewLabel = new JLabel("Nome: {{nome}}");
		lblNewLabel.setFont(new Font("Ubuntu Light", Font.BOLD, 16));
		panel_1.add(lblNewLabel);
		
		JLabel lblCoppieTrovate = new JLabel("Coppie trovate: 0");
		lblCoppieTrovate.setFont(new Font("Ubuntu Light", Font.BOLD, 16));
		panel_1.add(lblCoppieTrovate);
		
		JLabel lblTempo = new JLabel("Tempo trascorso: ");
		lblTempo.setFont(new Font("Ubuntu Light", Font.BOLD, 16));
		panel_1.add(lblTempo);
		
		memory = new Memory(panel, lblNewLabel, Helper.cards, Helper.username, lblCoppieTrovate);
		Clock clock = new Clock(lblTempo);
		clock.start();
		
	}
}
