package us.maccaleonardi.memory.card;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.Timer;

import us.maccaleonardi.memory.Memory;

public class CanvasCard extends Canvas implements MouseListener{

	private static final long serialVersionUID = 1L;
	private String image;
	public CanvasCard(String image) {
		
		super();
		this.image = image;
		addMouseListener(this);
		
	}
	
	@Override
	public void paint(Graphics g) {
		
		g.setColor(Color.white);
		g.fillRect(75, 60, getWidth() - 150, getHeight() - 120);
		
		
	}
	
	@Override
	public void mouseClicked(MouseEvent e) {
		
		CanvasCard clicked = (CanvasCard) e.getSource();
		
		if(Memory.visibleCards.size() < 2) {
			Memory.visibleCards.add(clicked); // card is visible, turned
			System.out.println("\n" + Memory.visibleCards.size());
			clicked.setBackground(Color.WHITE);
			System.out.print(clicked.getWidth());
			BufferedImage buff;
			try{
				buff = ImageIO.read(new FileInputStream(this.image));
				//Image newImage = buff.getScaledInstance(clicked.getWidth() / 4, clicked.getHeight() / 4, Image.SCALE_DEFAULT);
				ImageIcon icon = new ImageIcon(buff);
				clicked.getGraphics().drawImage(icon.getImage(), (clicked.getWidth() / 2) - 30, (clicked.getHeight() / 2) - 30, clicked);
				
			}catch(Exception ex) {
				
				ex.printStackTrace();
				
			}
			
			if(Memory.visibleCards.size() == 2) {
				
				CanvasCard[] stuff = Memory.getPair();
				CanvasCard f = stuff[0],
						   s = stuff[1];
				Card first_card = Memory.getCardByCanvas(f),
					 second_card = Memory.getCardByCanvas(s);
				
				if(first_card.equalsTo(second_card)) {
								
					ActionListener cover = new ActionListener() {
			            public void actionPerformed(ActionEvent evt) {
			            	Memory.pairings.remove(f);
							Memory.pairings.remove(s);
							Memory.visibleCards.clear();
							Memory.updateCouples();
							f.setBackground(Color.decode("#4cd137"));
							s.setBackground(Color.decode("#4cd137"));
							f.setEnabled(false);
							s.setEnabled(false);
							if(Memory.pairings.size() == 0) {
								
								System.out.println(Memory.pairings.size());
								JOptionPane.showMessageDialog(null, "Hai vinto!");
								Window window = SwingUtilities.windowForComponent(clicked);
								window.dispose();
								
							}
			            }
			        };
			        Timer timer = new Timer(1500, cover);
			        timer.setRepeats(false);
			        timer.start();			
					
				}else{
					
					ActionListener cover = new ActionListener() {
			            public void actionPerformed(ActionEvent evt) {
			                	Memory.visibleCards.clear();
			                	f.setBackground(Color.decode("#2f3640"));
			                	s.setBackground(Color.decode("#2f3640"));
			            }
			        };
			        Timer timer = new Timer(1500, cover);
			        timer.setRepeats(false);
			        timer.start();
					
				}
					
			}
		}
		else
			return;
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

}


